var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var eject_ras_exports = {};
__export(eject_ras_exports, {
  default: () => eject_ras_default
});
module.exports = __toCommonJS(eject_ras_exports);
var import_package_json = __toESM(require("@npmcli/package-json"));
var fs = __toESM(require("fs"));
var import_node_fetch = __toESM(require("node-fetch"));
var path = __toESM(require("path"));
async function eject_ras_default() {
  console.log("\u{1F680} Ejecting from Remix App Server...");
  await download("https://raw.githubusercontent.com/remix-run/remix/main/templates/express/package.json", "./__eject-ras__/package.json");
  const pkgJsonExpress = await import_package_json.default.load(path.resolve(process.cwd(), "./__eject-ras__"));
  const ts = new Date().toISOString().substring(0, 19).replace(/[-T:]/g, "");
  fs.copyFileSync(path.resolve(process.cwd(), "./package.json"), path.resolve(process.cwd(), `./package-${ts}.json`));
  const pkgJson = await import_package_json.default.load(process.cwd());
  const remixVersion = pkgJson.content.dependencies["@remix-run/node"];
  const dependencies = getDependencies(pkgJson.content.dependencies);
  dependencies.uninstall("@remix-run/serve");
  for (const [name, version] of Object.entries(pkgJsonExpress.content.dependencies)) {
    if (!dependencies.content[name]) {
      dependencies.install(name, version === "*" ? remixVersion : version);
    }
  }
  const devDependencies = getDependencies(pkgJson.content.devDependencies);
  for (const [name, version] of Object.entries(pkgJsonExpress.content.devDependencies)) {
    if (!devDependencies.content[name]) {
      devDependencies.install(name, version === "*" ? remixVersion : version);
    }
  }
  const scripts = { ...pkgJson.content.scripts };
  for (const [name, command] of Object.entries(pkgJsonExpress.content.scripts)) {
    if (name.startsWith("dev") || name.startsWith("start")) {
      console.log(`\u{1F4DD} updating script ${name}`);
      scripts[name] = command;
    }
  }
  pkgJson.update({
    dependencies: dependencies.content,
    devDependencies: devDependencies.content,
    scripts
  });
  await pkgJson.save();
  console.log("\u{1F4E6} downloading express server startup file");
  await download("https://raw.githubusercontent.com/remix-run/remix/main/templates/express/server.js", "./server.js");
  fs.unlinkSync(path.resolve(process.cwd(), "./__eject-ras__/package.json"));
  fs.rmdirSync(path.resolve(process.cwd(), "./__eject-ras__"));
  console.log("\u{1F3C1} Ejecting from Remix App Server... Done!\n");
  console.log("\u{1F528} run npm install to update your dependencies");
}
function getDependencies(dependencies) {
  const newDependencies = { ...dependencies };
  return {
    uninstall(name) {
      console.log(`\u{1F525} uninstalling ${name}`);
      delete newDependencies[name];
    },
    install(name, version) {
      console.log(`\u{1F4E6} installing ${name}@${version}`);
      newDependencies[name] = version;
    },
    content: newDependencies
  };
}
async function download(url, filepath) {
  const response = await (0, import_node_fetch.default)(url);
  const file = await response.text();
  const filedir = path.dirname(path.resolve(process.cwd(), filepath));
  if (!fs.existsSync(filedir)) {
    fs.mkdirSync(filedir, { recursive: true });
  }
  fs.writeFileSync(filepath, file);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
